<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2007 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2007 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_Loggers.php,v 1.15 2007/11/19 14:18:03 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * ϥ饹
 */
require_once 'SyL_Logger.php';

/**
 * ϥƥꥯ饹ʣݻ륯饹
 * 
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2007 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_Loggers.php,v 1.15 2007/11/19 14:18:03 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_Loggers
{
    /**
     * ƥꥪ֥ȳǼ
     * 
     * @access private
     * @var array
     */
    var $loggers = array();
    /**
     * ٥Ǽ
     * 
     * @access private
     * @var array
     */
    var $modes = array();

    /**
     * SyL_Loggers饹Υ󥹥󥹼
     *
     * @access public
     * @return object SyL_Loggers֥
     */
    function &singleton()
    {
        static $singleton;
        if (!is_object($singleton)) {
            $singleton = new SyL_Loggers();
        }
        return $singleton;
    }

    /**
     * ֥ȤΥå
     * 
     * @access public
     * @param object ֥
     * @param int ٥
     */
    function setLogger(&$logger, $mode=SYL_LOG)
    {
        if (($mode > SYL_LOG_NONE) && $logger) {
            $this->loggers[] =& $logger;
            $this->modes[]   =  $mode;
        }
    }

    /**
     * νϡERROR
     *
     * @access public
     * @param string å
     */
    function error($message)
    {
        $log =& SyL_Loggers::singleton();
        foreach (array_keys($log->loggers) as $key) {
            if ($log->modes[$key] >= SYL_LOG_ERROR) {
                $log->loggers[$key]->log('error', $log->formatLog($message));
            }
        }
    }

    /**
     * νϡWARN
     *
     * @access public
     * @param string å
     */
    function warn($message)
    {
        $log =& SyL_Loggers::singleton();
        foreach (array_keys($log->loggers) as $key) {
            if ($log->modes[$key] >= SYL_LOG_WARN) {
                $log->loggers[$key]->log('warn', $log->formatLog($message));
            }
        }
    }

    /**
     * νϡNOTICE
     *
     * @access public
     * @param string å
     */
    function notice($message)
    {
        $log =& SyL_Loggers::singleton();
        foreach (array_keys($log->loggers) as $key) {
            if ($log->modes[$key] >= SYL_LOG_NOTICE) {
                $log->loggers[$key]->log('notice', $log->formatLog($message));
            }
        }
    }

    /**
     * νϡINFO
     *
     * @access public
     * @param string å
     */
    function info($message)
    {
        $log =& SyL_Loggers::singleton();
        foreach (array_keys($log->loggers) as $key) {
            if ($log->modes[$key] >= SYL_LOG_INFO) {
                $log->loggers[$key]->log('info', $log->formatLog($message));
            }
        }
    }

    /**
     * νϡDEBUG
     *
     * @access public
     * @param string å
     */
    function debug($message)
    {
        $log =& SyL_Loggers::singleton();
        foreach (array_keys($log->loggers) as $key) {
            if ($log->modes[$key] >= SYL_LOG_DEBUG) {
                $log->loggers[$key]->log('debug', $log->formatLog($message));
            }
        }
    }

    /**
     * 
     *
     * @access public
     */
    function close()
    {
        foreach (array_keys($this->loggers) as $key) {
            $this->loggers[$key]->close();
        }
    }

    /**
     * 򷿤ˤäƤѹ
     *
     * @access private
     * @param mixed 
     * @return string 
     */
    function formatLog($message)
    {
        if (is_scalar($message)) {
            if (is_bool($message)) {
                return $message ? 'true' : 'false';
            } else {
                return (string)$message;
            }
        } else {
            return print_r($message, true);
        }
    }
}

?>
