<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2007 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2007 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_XmlRssReader0_91.php,v 1.2 2007/04/30 13:15:56 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * RSS 0.91꡼饹
 *
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2007 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_XmlRssReader0_91.php,v 1.2 2007/04/30 13:15:56 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_XmlRssReader0_91 extends SyL_XmlRssReader
{
    /**
     * XMLǡƼϥɥ᥽å
     *
     * @access protected
     * @param string XMLΥѥ
     * @param string XMLΥ°
     * @param string XMLΥ
     */
    function getElement($current_path, $attribute, $text)
    {
        // XMLϷ̤
        switch ($current_path) {
        // -------------------------------------------------
        // إå
        // -------------------------------------------------
        case '/rss/channel/copyright':      $this->channel['copyright']      = $text; break;
        case '/rss/channel/description':    $this->channel['description']    = $text; break;
        case '/rss/channel/docs':           $this->channel['docs']           = $text; break;
        case '/rss/channel/language':       $this->channel['language']       = $text; break;
        case '/rss/channel/lastBuildDate':  $this->channel['lastBuildDate']  = $this->convertDateTime($text); break;
        case '/rss/channel/link':           $this->channel['link']           = $text; break;
        case '/rss/channel/managingEditor': $this->channel['managingEditor'] = $text; break;
        case '/rss/channel/pubDate':
            $this->channel['pubDate'] = $text;
            $this->channel['date']    = $this->convertDateTime($text);
            break;
        case '/rss/channel/rating':         $this->channel['rating']      = $text; break;
        case '/rss/channel/skipHours':      $this->channel['skipHours']   = array(); break;
        case '/rss/channel/skipHours/hour': $this->channel['skipHours'][] = $text; break;
        case '/rss/channel/skipDays':       $this->channel['skipDays']    = array(); break;
        case '/rss/channel/skipDays/day':   $this->channel['skipDays'][]  = $text; break;
        case '/rss/channel/title':          $this->channel['title']       = $text; break;
        case '/rss/channel/webMaster':      $this->channel['webMaster']   = $text; break;

        // 
        case '/rss/channel/image':
            // ɬ°
            $this->channel['image'] = array();
            break;
        case '/rss/channel/image/url':         $this->channel['image']['url']         = $text; break;
        case '/rss/channel/image/title':       $this->channel['image']['title']       = $text; break;
        case '/rss/channel/image/link':        $this->channel['image']['link']        = $text; break;
        case '/rss/channel/image/width':       $this->channel['image']['width']       = $text; break;
        case '/rss/channel/image/height':      $this->channel['image']['height']      = $text; break;
        case '/rss/channel/image/description': $this->channel['image']['description'] = $text; break;

        // 
        case '/rss/channel/textInput':
            // ɬ°
            $this->channel['textinput'] = array();
            break;
        case '/rss/channel/textInput/title':       $this->channel['textinput']['title']       = $text; break;
        case '/rss/channel/textInput/name':        $this->channel['textinput']['name']        = $text; break;
        case '/rss/channel/textInput/description': $this->channel['textinput']['description'] = $text; break;
        case '/rss/channel/textInput/link':        $this->channel['textinput']['link']        = $text; break;

        // -------------------------------------------------
        // ǡ
        // -------------------------------------------------
        // RSS
        case '/rss/channel/item':
            // ɬ°
            $this->items[]    = array();
            $this->item_count = count($this->items);
            break;
        case '/rss/channel/item/title':       $this->items[$this->item_count-1]['title']       = $text; break;
        case '/rss/channel/item/link':        $this->items[$this->item_count-1]['link']        = $text; break;
        case '/rss/channel/item/description': $this->items[$this->item_count-1]['description'] = $text; break;
        }
    }
}

?>
